#
#    $Date: 1999/06/09 15:50:34 $
#    $Revision: 1.2 $
#

%instno = ( # ڴ̾Ȳֹб
	'Acoustic_Grand_Piano', '0',
	'Bright_Acoustic_Piano', '1',
	'Electric_Grand_Piano', '2',
	'Honky_Tonk_Piano', '3',
	'Rhodes_Piano', '4',
	'Chorused_Piano', '5',
	'Harpsichord', '6',
	'Clavinet', '7',
	'Celesta', '8',
	'Glockenspiel', '9',
	'Music_Box', '10',
	'Vibraphone', '11',
	'Marimba', '12',
	'Xylophone', '13',
	'Tubular_Bells', '14',
	'Dulcimer', '15',
	'Hammond_Organ', '16',
	'Percussive_Organ', '17',
	'Rock_Organ', '18',
	'Church_Organ', '19',
	'Reed_Organ', '20',
	'Accordion', '21',
	'Harmonica', '22',
	'Tango_Accordion', '23',
	'Acoustic_Guitar_nylon', '24',
	'Acoustic_Guitar_steel', '25',
	'Electric_Guitar_jazz', '26',
	'Electric_Guitar_clean', '27',
	'Electric_Guitar_muted', '28',
	'Overdriven_Guitar', '29',
	'Distortion_Guitar', '30',
	'Guitar_Harmonics', '31',
	'Acoustic_Bass', '32',
	'Electric_Bass_finger', '33',
	'Electric_Bass_pick', '34',
	'Fretless_Bass', '35',
	'Slap_Bass_1', '36',
	'Slap_Bass_2', '37',
	'Synth_Bass_1', '38',
	'Synth_Bass_2', '39',
	'Violin', '40',
	'Viola', '41',
	'Cello', '42',
	'Contrabass', '43',
	'Tremolo_Strings', '44',
	'Pizzicato_Strings', '45',
	'Orchestral_Harp', '46',
	'Timpani', '47',
	'String_Ensemble_1', '48',
	'String_Ensemble_2', '49',
	'SynthStrings_1', '50',
	'SynthStrings_2', '51',
	'Choir_Aahs', '52',
	'Voice_Oohs', '53',
	'Synth_Voice', '54',
	'Orchestra_Hit', '55',
	'Trumpet', '56',
	'Trombone', '57',
	'Tuba', '58',
	'Muted_Trumpet', '59',
	'French_Horn', '60',
	'Brass_Section', '61',
	'Synth_Brass_1', '62',
	'Synth_Brass_2', '63',
	'Soprano_Sax', '64',
	'Alto_Sax', '65',
	'Tenor_Sax', '66',
	'Baritone_Sax', '67',
	'Oboe', '68',
	'English_Horn', '69',
	'Bassoon', '70',
	'Clarinet', '71',
	'Piccolo', '72',
	'Flute', '73',
	'Recorder', '74',
	'Pan_Flute', '75',
	'Blown_Bottle', '76',
	'Shakuhachi', '77',
	'Whistle', '78',
	'Ocarina', '79',
	'Lead_1_square', '80',
	'Lead_2_sawtooth', '81',
	'Lead_3_calliope_lead', '82',
	'Lead_4_chiff_lead', '83',
	'Lead_5_charang', '84',
	'Lead_6_voice', '85',
	'Lead_7_fifths', '86',
	'Lead_8_brass_lead', '87',
	'Pad_1_new_age', '88',
	'Pad_2_warm', '89',
	'Pad_3_polysynth', '90',
	'Pad_4_choir', '91',
	'Pad_5_bowed', '92',
	'Pad_6_metallic', '93',
	'Pad_7_halo', '94',
	'Pad_8_sweep', '95',
	'FX_1_rain', '96',
	'FX_2_soundtrack', '97',
	'FX_3_crystal', '98',
	'FX_4_atmosphere', '99',
	'FX_5_brightness', '100',
	'FX_6_goblins', '101',
	'FX_7_echoes', '102',
	'FX_8_sci_fi', '103',
	'Sitar', '104',
	'Banjo', '105',
	'Shamisen', '106',
	'Koto', '107',
	'Kalimba', '108',
	'Bagpipe', '109',
	'Fiddle', '110',
	'Shanai', '111',
	'Tinkle_Bell', '112',
	'Agogo', '113',
	'Steel_Drums', '114',
	'Woodblock', '115',
	'Taiko_Drum', '116',
	'Melodic_Tom', '117',
	'Synth_Drum', '118',
	'Reverse_Cymbal', '119',
	'Guitar_Fret_Noise', '120',
	'Breath_Noise', '121',
	'Seashore', '122',
	'Bird_Tweet', '123',
	'Telephone_Ring', '124',
	'Helicopter', '125',
	'Applause', '126',
	'Gunshot', '127',
);
%note = ( # ̾Ȳֹб
    '', 60, '', 62, '', 64, 'ե', 65,
    '', 67, '', 69, '', 71, '', -1,
);
$notepat = join('|',keys(%note));
$level = 0;         # ͥȥ٥
$env[$level] = 's'; # par / ser
$channel = 1;
$unitlen = 100;

sub unitlen{    # ñ̻֤
    $unitlen = $_[0];
}
sub transpose{
    $transpose = $_[0];
}
sub inst {
    local($ch,$inst) = @_;
    $inst{$ch} = $instno{$inst};
    &add("0 PrCh ch=$ch p=$inst{$ch}\n",0);
}
sub channel {
    local($ch) = @_;
    $channel = $ch;
}
sub parbegin {
    &begin('p');
}
sub serbegin {
    &begin('s');
}
sub begin {
    $level++;
    $env[$level] = $_[0];
    $out[$level] = '';
    $len[$level] = 0;
}
sub serend {
    &parend;
}
sub parend {
    $level--;
    &add($out[$level+1],$len[$level+1]);
}
sub add { # ¸ǡ˿ǡɲ
    local($buf,$len) = @_;
    if($env[$level] eq 's'){ # ǡϢ
        $out[$level] .= &timeshift($buf,$len[$level]);
        $len[$level] += $len;
    }
    else { # ǡޡ
        $out[$level] = &timesort($out[$level].$buf);
        $len[$level] = ($len[$level] > $len ?
                $len[$level] : $len );
    }
}
sub play {
    local($_) = @_;
    local($t,$buf,$note,$notename);
    while($_ ne ''){
        if(s/^_//){
            $offset[$channel] -= 12; next;
        }
        if(s/^\^//){
            $offset[$channel] += 12; next;
        }
        if(s/^//){
            $t += $unitlen; next;
        }
        if(s/^($notepat)([#b]?)//){
            $notename = $1;
            $sharpflat = $2;
            if($t > 0 && $note > 0){
#                $buf .= sprintf("%d Off ch=%d n=%d v=0\n",
#                    $t-1,$channel,$note+$offset[$channel]);
                $buf .= sprintf("%d Off ch=%d n=%d v=0\n",
                    $t-1,$channel,$prevnote);
            }
            $note = $note{$notename};
            $note += ($sharpflat eq '#' ? 1 :
                  $sharpflat eq 'b' ? -1 : 0);
	    $note += $transpose;
            if($note > 0){
                $buf .= sprintf("%d On ch=%d n=%d v=96\n",
                $t,$channel,$note+$offset[$channel]);
            }
	    $prevnote = $note+$offset[$channel];
        }
        elsif(s/^([\x80-\xff])(.)//){
            $noteh = ord($1);
            $notel = ord($2);
            if($t > 0 && $note > 0){
                $buf .= sprintf("%d Off ch=%d n=%d v=0\n",
                    $t-1,$channel,$prevnote);
            }
            $note = ($noteh ^ $notel) % 40 + 50;
            if($note > 0){
                $buf .= sprintf("%d On ch=%d n=%d v=96\n",
                $t,$channel,$note+$offset[$channel]);
            }
	    $prevnote = $note+$offset[$channel];
        }
        else {
            s/^.//;
        }
        $t += $unitlen;
    }
    if($t > 0 && $note > 0){
#        $buf .= sprintf("%d Off ch=%d n=%d v=0\n",
#            $t-1,$channel,$note+$offset[$channel]);
        $buf .= sprintf("%d Off ch=%d n=%d v=0\n",
            $t-1,$channel,$prevnote);
    }
    &add($buf,$t);
}
sub bytime {
    local($ta,$tb);
    $a =~ /^(\d+)\s/;
    $ta = $1;
    $b =~ /^(\d+)\s/;
    $tb = $1;
    $ta <=> $tb;
}
sub timesort { # ٥Ȥ˥
    local($s) = @_;
    local(@a);
    @a = split(/\n/,$s);
    @a = sort bytime @a;
    join("\n",@a) . "\n";
}
sub timeshift { # ٥ȯ򥷥ե
    local($s,$t) = @_;
    local(@a,$i,$s1,$s2);
    @a = split(/\n/,$s);
    for($i=0;$i<=$#a;$i++){
        $a[$i] =~ /^(\d+)\s+(.*)$/;
        $s1 = $1; $s2 = $2;
        $a[$i] = $s1+$t . " $s2";
    }
    join("\n",@a) . "\n";
}
sub prologue {
    print "MFile 0 1 96\n";
    print "MTrk\n";
    print "0 Tempo 200000\n";
}
sub epilogue {
    print $out[0];
    print "$len[0] Meta TrkEnd\n";
    print "TrkEnd\n";
}
1;
